// DO NOT EDIT
// Generated by JFlex 1.9.1 http://jflex.de/
// source: jflex/ReadTable.jflex

/*******************************************************************************
 * Copyright (c) 2022-2029 Institute of Legal Information and Judicial Systems (IGSG-CNR)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 *  
 * Authors: Lorenzo Bacci (IGSG-CNR)
 ******************************************************************************/
package it.cnr.igsg.marker;


@SuppressWarnings("fallthrough")
public class ReadTable extends JFlexAnnotationService {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int inTable = 2;
  public static final int inPreTable = 4;
  public static final int inMrkPre = 6;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1,  1,  2,  2,  3, 3
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\36\u0200\1\u0300\u10df\u0200";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\1\0\1\1\1\3\22\0\1\1"+
    "\5\0\1\4\4\0\1\5\1\0\1\6\1\0\1\7"+
    "\12\0\1\10\1\11\1\12\1\13\1\14\3\0\1\15"+
    "\2\0\1\16\2\0\1\17\5\0\1\20\1\0\1\21"+
    "\1\0\1\22\1\23\13\0\1\24\2\0\1\15\2\0"+
    "\1\16\2\0\1\17\5\0\1\20\1\0\1\21\1\0"+
    "\1\22\1\23\10\0\1\5\u0102\0\1\23\u0182\0\1\1"+
    "\20\0\2\24\353\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1024];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\6\0\4\1\3\2\3\3\1\1\13\0\3\4\1\0"+
    "\2\5\2\0\1\5\31\0\1\6\34\0\2\7\3\0"+
    "\1\10\12\0\1\11\4\0\2\12\1\0\1\12\1\0"+
    "\1\13\7\0";

  private static int [] zzUnpackAction() {
    int [] result = new int[125];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\25\0\52\0\77\0\124\0\151\0\176\0\223"+
    "\0\250\0\275\0\176\0\322\0\347\0\176\0\374\0\u0111"+
    "\0\u0126\0\u013b\0\u0150\0\u0165\0\u017a\0\223\0\u018f\0\u01a4"+
    "\0\u01b9\0\u01ce\0\u01e3\0\u01f8\0\176\0\322\0\u020d\0\374"+
    "\0\176\0\u0222\0\u0237\0\u024c\0\374\0\u0261\0\u0276\0\u028b"+
    "\0\u02a0\0\u02b5\0\u02ca\0\u02df\0\u02f4\0\u0309\0\u031e\0\u0333"+
    "\0\u0348\0\u035d\0\u0372\0\u0387\0\u039c\0\u03b1\0\u03c6\0\u03db"+
    "\0\u03f0\0\u0405\0\u041a\0\u042f\0\u0444\0\u0459\0\u0459\0\u046e"+
    "\0\u0483\0\u0498\0\u04ad\0\u04c2\0\u04d7\0\u04ec\0\u0501\0\u0516"+
    "\0\u052b\0\u0540\0\u0555\0\u056a\0\u057f\0\u0594\0\u05a9\0\u05be"+
    "\0\u05d3\0\u05e8\0\u05fd\0\u0612\0\u0627\0\u063c\0\u0651\0\u0666"+
    "\0\u067b\0\u0690\0\u06a5\0\u06ba\0\u05a9\0\u06cf\0\u06e4\0\u06f9"+
    "\0\u05fd\0\u070e\0\u0723\0\u063c\0\u0738\0\u074d\0\u0762\0\u0777"+
    "\0\u078c\0\u07a1\0\u07b6\0\176\0\322\0\u07cb\0\u07e0\0\u07f5"+
    "\0\176\0\u080a\0\u081f\0\u078c\0\u0834\0\176\0\u0849\0\u085e"+
    "\0\u0873\0\u0888\0\u089d\0\u08b2\0\u08c7";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[125];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length() - 1;
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpacktrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\2\7\1\10\1\11\6\7\1\12\12\7\2\13\1\14"+
    "\1\15\21\13\2\16\1\17\1\20\21\16\12\7\1\21"+
    "\12\7\2\0\1\22\1\23\23\0\1\24\1\25\47\0"+
    "\1\26\2\0\1\27\1\30\1\31\4\0\1\32\10\0"+
    "\1\33\1\0\2\26\1\0\1\27\1\30\1\31\4\0"+
    "\1\32\10\0\1\33\17\0\1\34\5\0\1\35\1\36"+
    "\2\35\1\37\2\13\4\35\1\13\12\35\2\36\1\35"+
    "\1\37\2\13\4\35\1\13\11\35\1\0\1\40\1\41"+
    "\1\42\1\43\1\0\1\44\15\0\1\44\1\0\1\40"+
    "\1\45\1\42\1\43\1\0\1\44\15\0\1\44\7\0"+
    "\1\46\16\0\1\22\2\0\1\47\2\50\4\0\1\50"+
    "\12\0\2\22\1\0\1\47\2\50\4\0\1\50\12\0"+
    "\1\25\1\51\1\52\5\0\1\53\14\0\1\25\1\51"+
    "\1\54\5\0\1\53\33\0\1\55\11\0\1\56\1\57"+
    "\4\0\1\60\16\0\1\56\1\61\4\0\1\56\10\0"+
    "\1\62\5\0\2\56\4\0\1\60\17\0\1\62\15\0"+
    "\1\62\10\0\1\63\34\0\1\64\6\0\1\41\42\0"+
    "\1\65\12\0\1\66\15\0\1\66\17\0\1\67\25\0"+
    "\1\70\11\0\2\71\4\0\1\71\12\0\1\54\1\0"+
    "\1\54\5\0\1\72\14\0\1\52\1\51\1\54\5\0"+
    "\1\73\34\0\1\74\4\0\1\54\7\0\1\72\30\0"+
    "\1\75\14\0\2\76\4\0\1\76\16\0\1\76\1\77"+
    "\4\0\1\76\16\0\2\76\4\0\1\77\16\0\1\76"+
    "\1\100\4\0\1\76\10\0\1\101\6\0\1\101\15\0"+
    "\1\101\21\0\1\102\20\0\1\103\24\0\1\104\15\0"+
    "\1\105\15\0\1\105\10\0\1\106\31\0\1\107\14\0"+
    "\2\110\4\0\1\110\32\0\1\111\24\0\1\112\26\0"+
    "\1\113\24\0\1\114\6\0\2\115\4\0\1\115\16\0"+
    "\1\115\1\116\4\0\1\115\10\0\1\117\6\0\1\117"+
    "\15\0\1\117\22\0\1\120\25\0\1\121\24\0\1\122"+
    "\7\0\1\123\15\0\1\123\21\0\1\124\26\0\1\125"+
    "\6\0\2\126\4\0\1\126\34\0\1\127\24\0\1\130"+
    "\16\0\1\131\30\0\1\132\10\0\2\133\4\0\1\133"+
    "\16\0\1\133\1\134\4\0\1\133\10\0\1\135\6\0"+
    "\1\135\15\0\1\135\16\0\1\136\27\0\1\137\24\0"+
    "\1\140\11\0\1\141\15\0\1\141\22\0\1\142\23\0"+
    "\1\143\10\0\2\144\4\0\1\144\26\0\1\145\24\0"+
    "\1\146\27\0\1\147\15\0\1\26\14\0\1\150\1\151"+
    "\1\152\1\153\2\133\4\0\1\133\12\0\1\150\1\151"+
    "\1\152\1\153\1\133\1\134\4\0\1\133\10\0\1\135"+
    "\14\136\1\154\10\136\11\0\1\155\24\0\1\40\31\0"+
    "\1\156\17\0\1\22\33\0\1\157\24\0\1\160\10\0"+
    "\1\25\21\0\1\150\1\151\1\152\1\153\21\0\1\151"+
    "\1\161\1\162\1\163\21\0\1\151\1\164\1\162\1\163"+
    "\40\0\1\165\20\0\1\166\14\0\1\54\24\0\1\52"+
    "\22\0\1\161\42\0\1\167\21\0\1\170\24\0\1\171"+
    "\32\0\1\172\24\0\1\173\22\0\1\174\24\0\1\175"+
    "\14\0\1\150\24\0\1\151\13\0";

  private static int [] zzUnpacktrans() {
    int [] result = new int[2268];
    int offset = 0;
    offset = zzUnpacktrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpacktrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\6\0\1\11\3\1\1\11\2\1\1\11\3\1\13\0"+
    "\1\11\2\1\1\0\1\11\1\1\2\0\1\1\3\0"+
    "\2\1\1\0\1\1\22\0\1\1\34\0\2\1\3\0"+
    "\1\1\2\0\1\1\7\0\1\11\4\0\1\11\1\1"+
    "\1\0\1\1\1\0\1\11\7\0";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[125];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** For the backwards DFA of general lookahead statements */
  private boolean [] zzFin = new boolean [Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())+1];

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	
	ReadTable() { }
	
	private StringBuilder table = new StringBuilder();
	private StringBuilder buffer = new StringBuilder();
	
	String getTableText() {
	
		return table.toString().trim();
		
	}

	private void readTable() {
	
		if(getMarkerDocument().isDebug()) System.out.println("\nPARSE TABLE:\n\n\"" + table.toString() + "\"");
		
		//System.out.println("END TABLE: " + yytext());
	
		TableColumns tc = new TableColumns();
		tc.setMarkerDocument(getMarkerDocument());
		tc.setInput(table.toString());
		tc.run();
		
		//Se la tabella non è ben formattata (bordi laterali sempre coerenti), mettila in <pre>
		
		if( !tc.isWellFormatted() || !tc.isWellFormattedBottom()) {
		
			getMarkerDocument().setNotWellFormattedTables(true);
			
			if(getMarkerDocument().isDebug()) System.out.println("Tabella non ben formattata");
			
			output.append("<h:pre>" + table.toString() + "</h:pre>");		
		
		} else {
		
			Table t = new Table();
			t.setMarkerDocument(getMarkerDocument());
			t.setColumns(tc.getColumns());
			t.setInput(table.toString());
			t.run();
			output.append(t.getOutput());
		}
	}
	


  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  public ReadTable(java.io.Reader in) {
    this.zzReader = in;
  }


  /** Returns the maximum size of the scanner buffer, which limits the size of tokens. */
  private int zzMaxBufferLen() {
    return Integer.MAX_VALUE;
  }

  /**  Whether the scanner buffer can grow to accommodate a larger token. */
  private boolean zzCanGrow() {
    return true;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate && zzCanGrow()) {
      /* if not, and it can grow: blow it up */
      char newBuffer[] = new char[Math.min(zzBuffer.length * 2, zzMaxBufferLen())];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      if (requested == 0) {
        throw new java.io.EOFException("Scan buffer limit reached ["+zzBuffer.length+"]");
      }
      else {
        throw new java.io.IOException(
            "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
      }
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    int initBufferSize = Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen());
    if (zzBuffer.length > initBufferSize) {
      zzBuffer = new char[initBufferSize];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public int yylex() throws java.io.IOException
  {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
            switch (zzLexicalState) {
            case inTable: {
              //System.out.println("Fine inattesa tabella");
		
		//output.append(table.toString());
		
		readTable();
		
		return YYEOF;
            }  // fall though
            case 126: break;
            default:
        return YYEOF;
        }
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { output.append(yytext());
            }
          // fall through
          case 12: break;
          case 2:
            { table.append(yytext());
            }
          // fall through
          case 13: break;
          case 3:
            { buffer.append(yytext());
            }
          // fall through
          case 14: break;
          case 4:
            { /* Fine della tabella */
		
		readTable();
		
		table = new StringBuilder();
		
		yypushback(yylength());
		yybegin(0);
            }
          // fall through
          case 15: break;
          case 5:
            { output.append("<h:pre>" + table.toString() + "</h:pre>");
		
		output.append(buffer.toString() + yytext());
		
		yypushback(yylength());
		
		yybegin(0);
            }
          // fall through
          case 16: break;
          case 6:
            { yypushback(yylength());
	yybegin(inTable);
            }
          // fall through
          case 17: break;
          case 7:
            { table = new StringBuilder();
	buffer = new StringBuilder();
	
	table.append(yytext());
	
	yybegin(inPreTable);
            }
          // fall through
          case 18: break;
          case 8:
            { table.append(buffer.toString() + yytext());
		
		buffer = new StringBuilder();
            }
          // fall through
          case 19: break;
          case 9:
            { output.append(yytext()); yybegin(inMrkPre);
            }
          // fall through
          case 20: break;
          case 10:
            // general lookahead, find correct zzMarkedPos
            { int zzFState = 4;
              int zzFPos = zzStartRead;
              if (zzFin.length <= zzBufferL.length) {
                zzFin = new boolean[zzBufferL.length+1];
              }
              boolean zzFinL[] = zzFin;
              while (zzFState != -1 && zzFPos < zzMarkedPos) {
                zzFinL[zzFPos] = ((zzAttrL[zzFState] & 1) == 1);
                zzInput = Character.codePointAt(zzBufferL, zzFPos, zzMarkedPos);
                zzFPos += Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              }
              if (zzFState != -1) {
                zzFinL[zzFPos++] = ((zzAttrL[zzFState] & 1) == 1);
              }
              while (zzFPos <= zzMarkedPos) {
                zzFinL[zzFPos++] = false;
              }

              zzFState = 5;
              zzFPos = zzMarkedPos;
              while (!zzFinL[zzFPos] || (zzAttrL[zzFState] & 1) != 1) {
                zzInput = Character.codePointBefore(zzBufferL, zzFPos, zzStartRead);
                zzFPos -= Character.charCount(zzInput);
                zzFState = zzTransL[ zzRowMapL[zzFState] + zzCMap(zzInput) ];
              };
              zzMarkedPos = zzFPos;
            }
            { output.append("<h:pre>" + yytext() + "</h:pre>");
            }
          // fall through
          case 21: break;
          case 11:
            { output.append(yytext()); yybegin(0);
            }
          // fall through
          case 22: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }

  /**
   * Runs the scanner on input files.
   *
   * This is a standalone scanner, it will print any unmatched
   * text to System.out unchanged.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String[] argv) {
    if (argv.length == 0) {
      System.out.println("Usage : java ReadTable [ --encoding <name> ] <inputfile(s)>");
    }
    else {
      int firstFilePos = 0;
      String encodingName = "UTF-8";
      if (argv[0].equals("--encoding")) {
        firstFilePos = 2;
        encodingName = argv[1];
        try {
          // Side-effect: is encodingName valid?
          java.nio.charset.Charset.forName(encodingName);
        } catch (Exception e) {
          System.out.println("Invalid encoding '" + encodingName + "'");
          return;
        }
      }
      for (int i = firstFilePos; i < argv.length; i++) {
        ReadTable scanner = null;
        java.io.FileInputStream stream = null;
        java.io.Reader reader = null;
        try {
          stream = new java.io.FileInputStream(argv[i]);
          reader = new java.io.InputStreamReader(stream, encodingName);
          scanner = new ReadTable(reader);
          while ( !scanner.zzAtEOF ) scanner.yylex();
        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
        finally {
          if (reader != null) {
            try {
              reader.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
          if (stream != null) {
            try {
              stream.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
        }
      }
    }
  }


}
